unit UGravador;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, OleCtrls, voicerlibLib_TLB, ShellApi;

const
  MAX_CANAIS = 60;
  ENTRADA    = 0;
  INICIAL    = 1;
  DTMF       = 2;
  CALLING    = 3;
  ANSWER     = 4;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    btnStartVoicerlib: TButton;
    btnShutDownVoicerlib: TButton;
    GroupBox2: TGroupBox;
    memStatus: TMemo;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    txtTempoMaximoSilencio: TEdit;
    Label2: TLabel;
    vlib: Tvoicerlib;
    Label6: TLabel;
    txtTempoMinimoGravacao: TEdit;
    Label7: TLabel;
    chkAGC: TCheckBox;
    btnLimpar: TButton;
    Label3: TLabel;
    txtLimiarSilencio: TEdit;
    Label4: TLabel;
    Image1: TImage;
    procedure btnLimparClick(Sender: TObject);
    procedure btnStartVoicerlibClick(Sender: TObject);
    procedure btnShutDownVoicerlibClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure vlibRingDetected(ASender: TObject; Port: Smallint);
    procedure vlibRecording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
    procedure vlibFaxDetected(ASender: TObject; Port: Smallint);
    procedure vlibBusyDetected(ASender: TObject; Port: Smallint);
    procedure vlibSilenceDetected(ASender: TObject; Port, State: Smallint);
    procedure vlibCalling(ASender: TObject; Port: Smallint);
    procedure vlibRecordStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure txtTempoMaximoSilencioChange(Sender: TObject);
    procedure txtTempoMinimoGravacaoChange(Sender: TObject);
    procedure vlibDialToneDetected(ASender: TObject; Port: Smallint);
    procedure vlibDigitDetected(ASender: TObject; Port, Digit: Smallint);
    procedure vlibAnswerDetected(ASender: TObject; Port,
      AnswerType: Smallint);
    procedure Button1Click(Sender: TObject);
    procedure chkAGCClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function VoltaInicio(Port : integer):Boolean;
    function Chamando(Port : integer):Boolean;
    procedure fNumeroRecebido(Sender: TObject);
    procedure MostraStatus(nPorta: integer; sMess: string);
  end;

type
  TCanais = record
    sTipoLigacao  : String;  //'E' entrante 'S' sainte
    nDuracao      : Integer;
    nFlagStop     : Integer; // 0 - quando nao tem STOP      1 - quando executou STOP
    nFlagRestart  : integer;
    nStatus       : integer;
    sNumero       : String;
    TmrNumero     : TTimer;
    nFlagMostraDigitos : integer; // 0 - quando nao mostrou 1 - quando mostrou

end;

var
  Form1    : TForm1;
  rcCanais : TCanais;
  CN       : array[0..MAX_CANAIS] of TCanais;
  sDir     : String;
  sArqTemp : String;
  sReturn    : array [0..255] of Char;

implementation

{$R *.dfm}

procedure TForm1.MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' +sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.memStatus.Lines.Add(sMsg);
end;

procedure TForm1.fNumeroRecebido(Sender: TObject);
var
  nPorta,nRet : Integer;
begin
  nPorta := TTimer(Sender).Tag;

  //Se o ststus esta como atendido, parar a gravacao
  if (CN[nPorta].nFlagMostraDigitos = 1) and (Length(CN[nPorta].sNumero) > 2) then
  begin
    nRet := vlib.StopRecordFile(nPorta);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(nporta,'Erro ao parar gravacao - evento Timer.nCod ' + IntToStr(nRet));

    if CN[nporta].nStatus = CALLING then
      CN[nPorta].nFlagRestart:= 2//Deleta o arquivo sempre
    else
      //Flag para iniciar gravacao
      CN[nPorta].nFlagRestart:= 1;
  end;

  TTimer(Sender).Enabled := False;
  MostraStatus(nPorta,'Numero Discado: ' + CN[nPorta].sNumero);
  //Limpar
  CN[nPorta].sNumero := '';
  CN[nPorta].nFlagMostraDigitos := 1;

end;

procedure TForm1.btnLimparClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.btnStartVoicerlibClick(Sender: TObject);
var
  nRet,i : Integer;
begin

  //Inicializa a Voicerlib
  nRet := vlib.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));

  if nRet <> DG_EXIT_SUCCESS then
  begin
    MostraStatus(0,'Erro ao Inicializar a Voicerlib.Cod.' + IntToStr(nRet) + ' (' + sReturn + ') ');
    Exit;
  end
  else
    MostraStatus(0,'Voicerlib Inicializada com sucesso');

  sDir := ExtractFilePath(Application.ExeName) + 'Gravacoes\';
  if not DirectoryExists(sDir) then
    CreateDir(sDir);

  for i:=1 to vlib.GetPortsCount do
  begin
    CN[i].nFlagRestart := 0;
    CN[i].nFlagStop    := 0;
    CN[i].nStatus      := INICIAL;
    CN[i].sNumero      := '';

    CN[i].TmrNumero := TTimer.Create(Self);
    CN[i].TmrNumero.OnTimer := fNumeroRecebido;
    CN[i].TmrNumero.Enabled := False;
    CN[i].TmrNumero.Tag := i;

    //Seta o tipo de deteccao como DTMF
    vlib.SetDetectionType(i,DETECT_DTMF,DG_ENABLE);
    //vlib.SetPortGain(i,1,6);
    //Seta o formato de gravacao como PCM
    nRet := vlib.SetRecordFormat(i,ffWavePCM);
    if nRet <>  DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao setar o formato de gravao.Cod ' + IntToStr(nRet));

    //Cria thread de supervisao de linha
    nRet := vlib.CreateCallProgress(i,'cp_default.cfg');
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao criar thread de callprogress.Cod ' + IntToStr(nRet));

    //Habilita a thread de callprogress
    nRet := vlib.EnableCallProgress(i,CP_ENABLE_ALL);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao habilitar a thread de callprogress.Cod ' + IntToStr(nRet));

    //Habilita thread de InputBuffer
    if chkAGC.Checked then
      nRet := vlib.EnableInputBuffer(i,1)
    else
      nRet := vlib.EnableInputBuffer(i,0);

    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao habilitar a thread de InputBuffer.Cod ' + IntToStr(nRet));

    //Seta o limiar de silencio
    vlib.SetSilenceThreshold(i,StrToInt(txtLimiarSilencio.Text));
    //Habilita deteccao de audio/silencio - curto para inicio da chamada
    vlib.EnableSilenceDetection(i,10,10);

    //Testa se iniciou corretamente a monitoracao
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i, 'Erro ao iniciar a monitorao.nCod ' + IntToStr(nRet));

  end;
end;

procedure TForm1.btnShutDownVoicerlibClick(Sender: TObject);
var
  nRet,i : Integer;
begin

  for i:=1 to vlib.GetPortsCount do
  begin

    //Desabilita thread de InputBuffer
    nRet := vlib.DisableInputBuffer(i);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao desabilitar a thread de InputBuffer.nCod '  +  IntToStr(nRet));

    //Desabilita a thread de callprogress
    nRet := vlib.DisableCallProgress(i);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao desabilitar a thread de callprogress.nCod ' +  IntToStr(nRet));

    //Destroi thread de supervisao de linha
    nRet := vlib.DestroyCallProgress(i);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(i,'Erro ao destruir a thread de callprogress.nCod '+  IntToStr(nRet));
  end;

  //Finaliza a Voicerlib
  nRet := vlib.ShutdownVoicerLib;
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(0,'Erro ao Finalizar a Voicerlib.Cod.' + IntToStr(nRet))
  else
    MostraStatus(0,'Voicerlib Finalizada com sucesso');

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if vLib.DriverEnabled then
  begin
    Application.MessageBox('Finalize o Driver antes de fechar a aplicao!', 'Exemplo - Voicerlib', MB_OK);
    CanClose:= False;
  end;

end;

procedure TForm1.vlibRingDetected(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin

  MostraStatus(Port,'Ring...');

  CN[Port].sTipoLigacao := 'E';//Entrante
  MostraStatus(Port ,' Ligao Entrante');

  //Desabilita o atendimento
  nRet := vlib.DisableAnswerDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao desabilitar deteccao de atendimento.nCod ' + IntToStr(nRet));

  //Habilita supervisao de linha
  nRet := vlib.DisableCallProgress(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao desabilitar supervisao de linha - Ring.nCod ' + IntToStr(nRet));

  //Habilita supervisao de linha
  nRet := vlib.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao habilitar supervisao de linha - Ring.nCod ' + IntToStr(nRet));

  //Desabilita deteccao de silencio
  nRet := vlib.DisableSilenceDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao desabilitar deteccao de silencio. - Ring.nCod ' + IntToStr(nRet));

  //Habilita deteccao de silencio
  nRet := vlib.EnableSilenceDetection(Port,StrToInt(txtTempoMaximoSilencio.Text)*1000,1);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao habilitar deteccao de silencio. - Ring.nCod ' + IntToStr(nRet));

  //Se esta gravando
  if vlib.IsRecording(Port)  then
  begin
    //Para a gravacao
    nRet := vlib.StopRecordFile(Port);
    CN[Port].nFlagStop := 1; //Mandou parar e gerar o StopRecordFile
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,' Erro ao parar gravao no evento de Ring.nCod ' + IntToStr(nRet));
  end;

  if CN[Port].nStatus = CALLING then
    CN[Port].nFlagRestart := 2 //deleta sempre
  else
    CN[Port].nFlagRestart := 1;//Flag para iniciar a gravacao

  CN[Port].nStatus := ENTRADA ;

end;

procedure TForm1.vlibRecording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
begin
  MostraStatus(Port, ' Gravando....');
  CN[Port].nDuracao := ElapsedTime;
end;

procedure TForm1.vlibFaxDetected(ASender: TObject; Port: Smallint);
var
  nRet : integer;
begin

  if vlib.IsRecording(port) then
  begin
    CN[Port].nFlagStop := 1;//Mandou parar a gravacao  
    //Para a gravacao
    nRet := vlib.StopRecordFile(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port, ' Erro ao parar gravao no evento de Fax.nCod ' + IntTostr(nRet))
    else
      MostraStatus(Port, ' Parou gravao no evento de Fax');

    //Habilita supervisao de linha, deteccao de silencio e desabilita deteccao de atendimento
    if VoltaInicio(Port) = False then
      MostraStatus(Port,'Erro na funcao VoltaInicio');

  end;
end;

procedure TForm1.vlibBusyDetected(ASender: TObject; Port: Smallint);
var
  nRet : integer;
begin

  if vlib.IsRecording(Port) then
  begin
    //Se estiver no status de chamando, seta flag para deletar o arquivo
    if CN[Port].nStatus = CALLING then
      CN[Port].nFlagRestart := 2
    else
      CN[Port].nFlagRestart := 1;

    //Para a gravacao
    nRet := vlib.StopRecordFile(Port);
    CN[Port].nFlagStop := 1;//Mandou parar a gravacao
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port, ' Erro ao parar gravao no evento de Ocupado.nCod ' + IntToStr(nRet))
    else
      MostraStatus(Port, ' Parou gravao no evento de Ocupado');

    //Habilita supervisao de linha, deteccao de silencio e desabilita deteccao de atendimento
    if VoltaInicio(Port) = False then
      MostraStatus(Port,'Erro na funcao VoltaInicio');

  end;
end;

procedure TForm1.vlibSilenceDetected(ASender: TObject; Port,
  State: Smallint);
var
  nRet : Integer;
begin

  if State =  DG_SILENCE_DETECTED then //SILENCIO
  begin
    //Se esta gravando
    if vlib.IsRecording(Port) then
    begin
      //Para a gravacao
      nRet := vlib.StopRecordFile(Port);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port, ' Erro ao parar gravao no evento de Silencio.nCod ' + IntToStr(nRet));

      CN[Port].nFlagStop := 1;//Mandou parar a gravacao

      if CN[Port].nStatus = CALLING then
        CN[Port].nFlagRestart := 2; //Deleta o arquivo sempre
    end;

    if CN[port].nStatus <> INICIAL then
    begin
      CN[Port].nStatus := INICIAL;
      VoltaInicio(Port);
    end;

  end
  else //AUDIO
  begin

    //Se for status inicial, habilita callprogress e muda o status
    if CN[Port].nStatus = INICIAL then
    begin

      if Chamando(Port) = False then
        MostraStatus(Port,'Erro na funcao Chamando no evento de silencio(AUDIO)');

    end;

    //Se nao esta gravando
    if vlib.IsRecording(Port) = False then
    begin
      sArqTemp := sDir + 'Gravacao_'+ FormatDateTime('yyyymmddhhmmss', now) + '.wav';

      if CN[Port].nFlagStop = 1 then
        CN[Port].nFlagRestart := 1
      else
      begin
        //Comeca a gravar
        nRet := vlib.RecordFile(Port,sArqTemp,'');
        MostraStatus(Port, 'SilenceDetected - RecordFile');
        if nRet <> DG_EXIT_SUCCESS then
          MostraStatus(Port, 'Erro ao iniciar gravao no evento de Silencio.nCod ' + IntToStr(nRet));
      end;
    end;
  end;
end;

procedure TForm1.vlibCalling(ASender: TObject; Port: Smallint);
begin

  MostraStatus(Port,'Calling...');

  if Chamando(Port) = False then
    MostraStatus(Port,'Erro na funcao Chamando no evento de calling');

end;

procedure TForm1.vlibRecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : integer;
begin

  MostraStatus(Port,'Parou gravao');
  CN[Port].nFlagStop := 0;//Ja parou

  //Tempo de duracao de gravacao tem que ser menor que o tempo minimo de gravacao
  if ((CN[Port].nDuracao) < (StrToInt(txtTempoMinimoGravacao.Text))) or (CN[Port].nFlagRestart = 2) then
  begin
    //Apaga o arquivo pois ele eh menor que o tempo minimo de gravacao
    DeleteFile(sArqTemp);
  end;

  CN[Port].nDuracao := 0;
  //Desabilita deteccao de atendimento
  nRet := vlib.DisableAnswerDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao desabilitar deteccao de atendimento - RecordStop.nCod ' + IntToStr(nRet));

  if CN[Port].nFlagRestart = 1 then
  begin
    //Desabilita deteccao de atendimento
    nRet := vlib.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao desabilitar deteccao de silencio no evento de RecordStop.nCod ' + IntToStr(nRet));

    //Habilita deteccao de atendimento
    nRet := vlib.EnableSilenceDetection(Port,(StrToInt(txtTempoMaximoSilencio.Text)*1000),1);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao habilitar deteccao de silencio no evento de RecordStop.nCod ' + IntToStr(nRet));

    sArqTemp := sDir + 'Gravacao_'+ FormatDateTime('yyyymmddhhmmss', now) + '.wav';

    //Inicia gravacao
    nRet := vlib.RecordFile(Port,sArqTemp,'');
    MostraStatus(Port, 'RecordFile evento de recordstop');
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,' Erro ao iniciar gravao no evento de RecordStop.nCod ' + IntToStr(nRet))
    else
      MostraStatus(Port, ' Iniciou gravao no evento de RecordStop');

  end
  else
  begin

    //Desabilita deteccao de atendimento
    nRet := vlib.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao desabilitar deteccao de silencio no evento de RecordStop.nCod ' + IntToStr(nRet));

    //Habilita deteccao de atendimento
    nRet := vlib.EnableSilenceDetection(Port,10,10);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao habilitar deteccao de silencio no evento de RecordStop.nCod ' + IntToStr(nRet));
  end;

  CN[Port].nFlagRestart := 0;
  
end;

procedure TForm1.txtTempoMaximoSilencioChange(Sender: TObject);
begin


  if txtTempoMaximoSilencio.Text = '' then
    txtTempoMaximoSilencio.Text := '0';

  // tempo minimo de grav tem q ser maior que o de tempo de silencio
  if (StrToInt(txtTempoMinimoGravacao.Text) <= (StrToInt(txtTempoMaximoSilencio.Text))) then
    ShowMessage('O tempo mnimo de gravao tem que ser maior que o tempo de silncio');

end;

procedure TForm1.txtTempoMinimoGravacaoChange(Sender: TObject);
begin

  if txtTempoMinimoGravacao.Text = '' then
    txtTempoMinimoGravacao.Text := '0';

  // tempo minimo de grav tem q ser maior que o de tempo de silencio
  if (StrToInt(txtTempoMinimoGravacao.Text) <= (StrToInt(txtTempoMaximoSilencio.Text))) then
    ShowMessage('O tempo mnimo de gravao tem que ser maior que o tempo de silncio');
end;

procedure TForm1.vlibDialToneDetected(ASender: TObject; Port: Smallint);
var
  nRet : integer;
begin

  MostraStatus(Port,'DialToneDetected');
  CN[Port].sTipoLigacao := 'S';
  MostraStatus(Port, 'Ligao de Sada');

  if Chamando(Port) = False then
    MostraStatus(Port,'Erro na funcao Chamando no evento de DialToneDetected');

  if vlib.IsRecording(Port) then
  begin
    //Para gravacao
    nRet := vlib.StopRecordFile(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao parar gravacao evento DialToneDetected.nCod ' + IntToStr(nRet));
    CN[Port].nFlagRestart := 1;
  end;

end;

procedure TForm1.vlibDigitDetected(ASender: TObject; Port,
  Digit: Smallint);

var
  nRet : Integer;
begin

  MostraStatus(Port,'Digito: ' + Chr(Digit));

  //Primeiro
  if CN[Port].sNumero = '' then
  begin

    CN[port].TmrNumero.Enabled := true;

    if Chr(Digit) = 'A' then// Inicio do BINA
    begin
      CN[Port].nStatus := ENTRADA;

      //Desabilita o atendimento
      nRet := vlib.DisableAnswerDetection(Port);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'Erro ao desabilitar deteccao de atendimento.nCod ' + IntToStr(nRet));

      //Desabilitar supervisao de linha
      nRet := vlib.DisableCallProgress(Port);
      if nRet <> DG_EXIT_SUCCESS  then
        MostraStatus(Port,'Erro ao desabilitar callprogress.nCod ' + IntToStr(nRet));

      //Habilita supervisao de linha
      nRet := vlib.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
      if nRet <> DG_EXIT_SUCCESS  then
        MostraStatus(Port,'Erro ao habilitar callprogress - DigitDetected.nCod ' + IntToStr(nRet));

      //Desabilita deteccao de silencio
      nRet := vlib.DisableSilenceDetection(Port);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'Erro ao desabilitar deteccao de silencio. - DigitDetected.nCod ' + IntToStr(nRet));

      //Habilita deteccao de silencio
      nRet := vlib.EnableSilenceDetection(Port,StrToInt(txtTempoMaximoSilencio.Text)*1000,1);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'Erro ao habilitar deteccao de silencio. - DigitDetected.nCod ' + IntToStr(nRet));
    end
    else // Eh o primeiro porem nao eh o 65
    begin
      CN[Port].sNumero := Chr(Digit);
      CN[port].TmrNumero.Enabled := True;
    end;
  end
  else//Nao eh o primeiro
  begin
    if Chr(Digit) = 'C' then
    begin
      CN[port].TmrNumero.Enabled := False;
      MostraStatus(port,'BINA: ' + CN[Port].sNumero);
      //Zera
      CN[Port].sNumero := '';
      CN[Port].nFlagMostraDigitos := 1;
    end
    else
    begin
      CN[Port].sNumero := CN[Port].sNumero + Chr(Digit);
      CN[port].TmrNumero.Enabled := False;
      CN[Port].TmrNumero.Interval := 5000;
      CN[port].TmrNumero.Enabled := True;
    end;

  end;
end;

procedure TForm1.vlibAnswerDetected(ASender: TObject; Port,
  AnswerType: Smallint);
var
  nRet : Integer;
begin
  MostraStatus(Port,'AnswerDetected');

  CN[Port].nStatus := ANSWER;

  //Desabilitar supervisao de linha
  nRet := vlib.DisableCallProgress(Port);
  if nRet <> DG_EXIT_SUCCESS  then
    MostraStatus(Port,'Erro ao desabilitar callprogress.nCod ' + IntToStr(nRet));

  //Habilita supervisao de linha
  nRet := vlib.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
  if nRet <> DG_EXIT_SUCCESS  then
    MostraStatus(Port,'Erro ao habilitar callprogress - Answer.nCod ' + IntToStr(nRet));

  //Desabilita deteccao de silencio
  nRet := vlib.DisableSilenceDetection(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao desabilitar deteccao de silencio. - Answer.nCod ' + IntToStr(nRet));

  //Habilita deteccao de silencio  
  nRet := vlib.EnableSilenceDetection(Port,StrToInt(txtTempoMaximoSilencio.Text)*1000,1);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'Erro ao habilitar deteccao de silencio. - Answer.nCod ' + IntToStr(nRet));


end;

function TForm1.VoltaInicio(Port : integer):Boolean ;
var
  nRet : Integer;
begin
  try
    Result := true;
    CN[Port].nFlagMostraDigitos := 0;

    //Desabilitar supervisao de linha
    nRet := vlib.DisableCallProgress(Port);
    if nRet <> DG_EXIT_SUCCESS  then
      MostraStatus(Port,'Erro ao desabilitar callprogress.nCod ' + IntToStr(nRet));

    //Habilita supervisao de linha
    nRet := vlib.EnableCallProgress(Port,CP_ENABLE_ALL);
    if nRet <> DG_EXIT_SUCCESS  then
      MostraStatus(Port,'Erro ao habilitar callprogress.nCod ' + IntToStr(nRet));

    //Desabilita deteccao de silencio
    nRet := vlib.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao desabilitar deteccao de silencio.nCod ' + IntToStr(nRet));

    //Habilita deteccao de silencio - tempo curto
    nRet := vlib.EnableSilenceDetection(Port,10,10);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao habilitar deteccao de silencio.nCod ' + IntToStr(nRet));

    //Desabilita o atendimento
    nRet := vlib.DisableAnswerDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
       MostraStatus(Port,'Erro ao desabilitar deteccao de atendimento.nCod ' + IntToStr(nRet));

    CN[Port].nStatus := INICIAL;
  except
    Result := False;
  end;
end;

function TForm1.Chamando(Port : integer):Boolean;
var
  nRet : Integer;
begin
  try
    Result := True;

    //Desabilita deteccao de silencio
    nRet := vlib.DisableSilenceDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao desabilitar deteccao de silencio.nCod ' + IntToStr(nRet));

    //Habilita deteccao de silencio
    nRet := vlib.EnableSilenceDetection(Port,StrToInt(txtTempoMaximoSilencio.Text)*1000,1);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao habilitar deteccao de silencio.nCod ' + IntToStr(nRet));

    //Habilita deteccao de atendimento
    nRet := vlib.EnableAnswerDetection(Port);
    if nRet <> DG_EXIT_SUCCESS then
       MostraStatus(Port,'Erro ao habilitar deteccao de atendimento.nCod ' + IntToStr(nRet));

    CN[Port].nStatus := CALLING;
  except
    Result := False;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  L: String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);
end;

procedure TForm1.chkAGCClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 1 to vlib.GetPortsCount do
  begin
    if chkAGC.Checked then
      vlib.EnableInputBuffer(i,1)
    else
      vlib.EnableInputBuffer(i,0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var 
  cVersao : array[0..255] of Char;
  nRet : Integer;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

end;

end.

